	    TITLE   Beispiel Positionsabfrage
	    .286

; Stacksegment einrichten
SSEG	    SEGMENT STACK
	    DB	    32	DUP("STACK---")
SSEG	    ENDS

; Datensegment einrichten
DSEG	    SEGMENT

; String fuer Ausgabe und Stringlaenge
signon	    DB	    'Positionsabfrage',0dh,0ah
l_signon    EQU     $-signon

; String fuer Positionsmeldung und Stringlaenge
posanz	    DB	    'Position: '
l_posanz    EQU     $-posanz

; Puffer fuer Position
posbuffer   DB	    'xxxxyyyyzzzz'
position    DB	    'xxxxyyyyzzzz'

; String fuer Positionsmeldung und Stringlaenge
posstring   DB	    'X:xxxxxxxxh Y:yyyyyyyyh Z:zzzzzzzzh',0dh,0ah
l_posstring EQU     $-posstring

; Tabelle fuer Umwandlung nach ASCII-HEX
h_table     DB	    30h,31h,32h,33h,34h,35h,36h,37h,38h,39h
	    DB	    41h,42h,43h,44h,45h,46h

DSEG	    ENDS

; Codesegment
CSEG	    SEGMENT 'CODE'
	    ASSUME  CS:CSEG, SS:SSEG, DS:DSEG

; Hauptroutine
MAIN	    PROC FAR

; Stack initialisieren
	    PUSH    DS
	    PUSH    0

; String ausgeben
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     BX, 0001h
	    LEA     DX, signon
	    MOV     CX, l_signon
	    MOV     AH, 40h
	    INT     21h

; Positionsmeldung ausgeben
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     BX, 0001h
	    LEA     DX, posanz
	    MOV     CX, l_posanz
	    MOV     AH, 40h
	    INT     21h

; Register vorbereiten
	    MOV     AX, DSEG
	    MOV     DS, AX
; Segment und Offset Positionspuffer
	    MOV     BX, AX
	    LEA     CX, posbuffer
; Funktionscode 18, Positionsabfrage
	    MOV     AX, 18
; Softwareinterrupt 78 aufrufen
	    INT     78h

; Reihenfolge der Bytes im Puffer umdrehen
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     ES, AX
	    CLD
	    LEA     SI, posbuffer
	    LEA     DI, position
	    CALL    SWAP4
	    LEA     SI, posbuffer+4
	    LEA     DI, position+4
	    CALL    SWAP4
	    LEA     SI, posbuffer+8
	    LEA     DI, position+8
	    CALL    SWAP4

; Umwandlung nach ASCII-HEX
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     ES, AX
	    LEA     SI, position
	    LEA     DI, posstring+2
	    MOV     CX, 4
	    CLD
	    LEA     BX, h_table
	    CALL    DECODE
	    LEA     DI, posstring+14
	    MOV     CX, 4
	    CALL    DECODE
	    LEA     DI, posstring+26
	    MOV     CX, 4
	    CALL    DECODE

; Ausgabe der Position
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     BX, 0001h
	    LEA     DX, posstring
	    MOV     CX, l_posstring
	    MOV     AH, 40h
	    INT     21h

;und Ende
	    RET
MAIN	    ENDP

; Procedur Umwandlung nach ASCII-HEX
DECODE	    PROC
	L1:
	    LODSB
	    PUSH    AX
	    SHR     AX, 4
	    AND     AX, 000fh
	    XLAT
	    STOSB
	    POP     AX
	    AND     AX, 000fh
	    XLAT
	    STOSB
	    LOOP    L1
	    RET
DECODE	    ENDP

; Procedur Bytes tauschen
SWAP4	    PROC
	    LODSB
	    PUSH    AX
	    LODSB
	    PUSH    AX
	    LODSB
	    PUSH    AX
	    LODSB
	    STOSB
	    POP     AX
	    STOSB
	    POP     AX
	    STOSB
	    POP     AX
	    STOSB
	    RET
SWAP4	    ENDP

; Ende Codesegment
CSEG	    ENDS

; Ende Modul
	    END     MAIN
