	    TITLE   Beispiel Relative Bewegung
	    .286

; Stacksegment einrichten
SSEG	    SEGMENT STACK
	    DB	    32	DUP("STACK---")
SSEG	    ENDS

; Datensegment einrichten
DSEG	    SEGMENT

; String fuer Ausgabe
signon	    DB	    'Relative Bewegnung',0dh,0ah
l_signon    EQU     $-signon

; Puffer fuer Zielposition
posbuffer   DB	    00h,0ch,00h,00h
	    DB	    00h,08h,00h,00h
	    DB	    00h,04h,00h,00h

; String fuer OK-Message
okmess	    DB	    'OK',0dh,0ah
l_okmess    EQU	    $-okmess

; String fuer Fehlermeldung
fehler	    DB	    'Fehler: xxh',0dh,0ah
l_fehler    EQU	    $-fehler

; Tabelle fuer Umwandlung in Hexziffern
h_table     DB	    30h,31h,32h,33h,34h,35h,36h,37h,38h,39h
	    DB	    41h,42h,43h,44h,45h,46h

DSEG	    ENDS

; Codesegment
CSEG	    SEGMENT 'CODE'
	    ASSUME  CS:CSEG, SS:SSEG, DS:DSEG

; Hauptroutine
MAIN	    PROC FAR

; Stack initialisieren
	    PUSH    DS
	    PUSH    0

; String ausgeben
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     BX, 0001h
	    LEA     DX, signon
	    MOV     CX, l_signon
	    MOV     AH, 40h
	    INT     21h

; Register vorbereiten
	    MOV     AX, DSEG
	    MOV     DS, AX
; Segment und Offset der Zielposition in Register laden
	    MOV     BX, AX
	    LEA     CX, posbuffer
; Funktionscode 24, relative Bewegung
	    MOV     AX, 24
; Softwareinterrupt 78 aufrufen
	    INT     78h

	L1:
; Rueckmeldung sichern
	    PUSH    AX
	    AND     AX, 00ffh
; Fehlercode auf 0 testen
	    CMP     AX, 0
	    JE	    L2
; wenn Fehler dann Fehlermeldung ausgeben
	    CALL    ERRMESS
	    POP     AX
	    JMP     L4
	L2:
; Rueckmeldung
	    POP     AX
; Bewegungsstatus testen
	    AND     AX, 4100h
            CMP     AX, 0
            JE      L3
; Funktionscode 5, Status abfragen
	    MOV     AX, 5
; Softwareinterrupt 78 aufrufen
	    INT     78h
; Schleife bis Ende Bewegung oder Fehler
	    JMP     L1
        L3:
; OK-Message ausgeben
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     BX, 0001h
	    LEA     DX, okmess
	    MOV     CX, l_okmess
	    MOV     AH, 40h
	    INT     21h
	L4:
; und Ende
	    RET
MAIN	    ENDP

; Procedur Fehlermeldung ausgeben
ERRMESS	    PROC
; Register vorbereiten
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     ES, AX
; Fehlercode nach ASCII-HEX umwandeln
	    LEA     DI, fehler+8
	    CLD
	    LEA     BX, h_table
	    PUSH    AX
	    SHR     AX, 4
	    AND     AX, 000fh
	    XLAT
	    STOSB
	    POP     AX
	    AND     AX, 000fh
	    XLAT
	    STOSB
; Fehlermeldung ausgeben
	    MOV     AX, DSEG
	    MOV     DS, AX
	    MOV     BX, 0001h
	    LEA     DX, fehler
	    MOV     CX, l_fehler
	    MOV     AH, 40h
	    INT     21h
; und zurueck
	    RET
ERRMESS	    ENDP


CSEG	    ENDS
; Ende Modul
	    END     MAIN
