#ifndef MSPBAHN_H
#define MSPBAHN_H

				       /* bergabeparameter */
typedef struct uebergabe
   {
	long Break_Key; 	       /* Code fr Unterbrechungstaste	  */
	long ErrorCode; 	       /* Fehlercode			  */
	long SourceZeileNr;	       /* Zeilennummer im Sourcefile	  */
	long Kreisebene;	       /* vordefinierte Kreisebene	  */
	long NullX;		       /* Nullpunktkoordinate X-Achse	  */
	long NullY;		       /* Nullpunktkoordinate Y-Achse	  */
	long NullZ;		       /* Nullpunktkoordinate Z-Achse	  */
	long AktX;		       /* aktuelle Koordinate X 	  */
	long AktY;		       /* aktuelle Koordinate Y		  */
	long AktZ;		       /* aktuelle Koordinate Z		  */
	char _far *Inifile;	       /* Zeiger auf Inidateiname	  */
	char _far *Quellfile;	       /* Zeiger auf Quelldateiname	  */
	char _far *Zielfile;	       /* Zeiger auf Zieldateiname	  */
	void _far *Dummy1;	       /* Pointer auf Anwenderfunktion	  */
   } BDGPARAMETER;

extern void BahnDatenGenerator(BDGPARAMETER far *);

#endif

#ifndef MK_FP
#define MK_FP(seg,ofs) \
	   ((void far *) (((unsigned long) (seg) << 16) | (unsigned) (ofs)))
#endif
