{ Example for Int78, Simulation der Referenzfahrt }

uses DOS,
     Crt;
var
  regs : Registers;
  Pos : Array[0..2] of longint;
  status : byte;

begin
  Pos[0] := 0;
  Pos[1] := 0;
  Pos[2] := 0;

  Window(1,1,80,25);
  ClrScr;
  GotoXY(2,18); Write('REFERENZ TESTMODE');

  regs.ax := 3;   { Functioncode 3, Testmode }
  regs.bx := 1;   { On }
  Intr($78,regs); { Call Int78 }
  GotoXY(2,19); Write('TESTMODE EIN');

  regs.ax := 6;   { Functioncode 6, Referencemove }
  regs.bx := 7;   { XYZ-Axis }
  Intr($78,regs); { Call Int78 }
  GotoXY(2,20); Write('REFERENZ');

  regs.ax := 5;   { Functioncode 5, Statusrequest }
  Intr($78,regs); { Call Int78 }
  status := regs.ah and $41;
  while status<>0 do
  begin
    regs.ax := 5;   { Functioncode 5, Statusrequest }
    Intr($78,regs); { Call Int78 }
    status := regs.ah and $41;
    GotoXY(2,22); Write('Status:',regs.ah);
    GotoXY(2,23); Write('Fehler:',regs.al);
  end;

  regs.ax := 3;   { Functioncode 3, Testmode }
  regs.bx := 0;   { Off }
  Intr($78,regs); { Call Int78 }
  GotoXY(2,21); Write('TESTMODE AUS');

  regs.ax := 5;   { Funktioncode 5, Statusrequest }
  Intr($78,regs); { Call Int78 }

  GotoXY(2,22); Write('Status:',regs.ah);
  GotoXY(2,23); Write('Fehler:',regs.al);

  regs.ax := 18;  { Functioncode 18, Positionrequest }
  regs.bx := Seg(Pos);
  regs.cx := Ofs(Pos);
  Intr($78,regs); { Call Int78 }

  GotoXY(2,24); Write('X:',Pos[0]);
  GotoXY(17,24);Write('Y:',Pos[1]);
  GotoXY(32,24);Write('Z:',Pos[2]);

end.
